﻿init python:
    def cards_pay(winner, loser, bet):
        winner.cash -= bet
        loser.cash += bet
    class blackjack_class:
        def __init__(self, player, enemy):
            self.player = player
            self.enemy = enemy
            self.player.escape = (self.player.cash/2)
            self.enemy.escape = (self.enemy.cash/2)
            self.turn = 0
            self.revealed = False

            self.first_deal_count = 1

            self.bet = 1
        def set_bet(self, amount):
            self.bet += amount
            if self.bet < 1:
                self.bet = 1
            self.cash_check()
        def cash_check(self):
            if self.player.cash < self.bet:
                self.bet = self.player.cash
            if self.enemy.cash < self.bet:
                self.bet = self.enemy.cash
        def pay(self, winner, amount):
            if winner == "player":
                self.player.cash += amount
                self.enemy.cash -= amount
                self.enemy.escape -= amount
            else:
                self.enemy.cash += amount
                self.player.cash -= amount
                self.player.escape -= amount
        def first_deal(self):
            if len(self.player.hand) < 2 or len(self.enemy.hand) < 2:
                if (self.first_deal_count % 2) and len(self.player.hand) < 2:
                    self.player.hand.append(self.player.deck.pop())
                elif len(self.enemy.hand) < 2:
                    self.enemy.hand.append(self.player.deck.pop())
                self.first_deal_count += 1
            else:
                self.turn = 2
        def draw(self, index = False):
            if index:
                self.enemy.hand.append(self.player.deck.pop())
            else:
                self.player.hand.append(self.player.deck.pop())

        def set_turn(self, turn):
            self.turn = turn
            if turn == 0:
                self.revealed = False
                self.cash_check()
            elif turn == 3:
                self.revealed = True
            elif turn == 4:
                self.revealed = True
        def next(self):
            self.player.hand = []
            self.enemy.hand = []
            self.set_turn(0)
        def escape_check(self):
            chance = renpy.random.randint(1, 100)
            if chance < 20:
                return "enemy ran"


screen blackjack_screen(g):
    modal True
    default coin = "cards/coins.png"

    style_prefix "card_games"

    hbox: # Enemy's cash
        align 0.0,0.0 offset 15,15
        add coin
        text "{}".format(g.enemy.cash) size 35 color "#ff6"
    hbox: # Player's cash
        align 1.0,1.0 offset -15,-15
        text "{}".format(g.player.cash) size 35 color "#ff6"
        add coin

    fixed: # Deck
        align(1.0,0.5) xoffset -16
        fit_first True
        at card_game_ani
        add "cards/back.webp" at zoom(.4)
    if g.player.escape < 1:
        button:
            align 0.0,1.0 padding 0,0
            fixed:
                fit_first True
                add "cards/run.png"
                text _("End") align .2,.8
            action Return("player ran")


    # Betting
    if g.turn == 0:
        if len(g.player.deck) < 16: # low cards re shuffle
            timer .01 action Function(g.player.build)
        if g.enemy.escape < 1:
            timer .2 action Function(g.escape_check)


        button:
            align .5,.5 yoffset 120
            xysize 308,108 background "cards/btn.png" hover_background "cards/btn1.png"
            text "Bet" align .5,.5
            action Function(g.set_turn, 1)
        fixed:
            fit_first True align .5,.5
            add "cards/bet.png"
            hbox:
                align .5,.5 spacing 10
                hbox:
                    spacing 10
                    button:
                        xysize 54,70 background "cards/arrow.png" hover_background "cards/arrow1.png"
                        action Function(g.set_bet, -10)
                    button:
                        align .5,.5
                        at zoom(.6)
                        xysize 54,70 background "cards/arrow.png" hover_background "cards/arrow1.png"
                        action Function(g.set_bet, -1)
                label str(g.bet) xsize 220 background None align .5,.5 text_align .5,.5
                hbox:
                    spacing 10
                    at flip
                    button:
                        xysize 54,70 background "cards/arrow.png" hover_background "cards/arrow1.png"
                        action Function(g.set_bet, 10)
                    button:
                        align .5,.5
                        at zoom(.6)
                        xysize 54,70 background "cards/arrow.png" hover_background "cards/arrow1.png"
                        action Function(g.set_bet, 1)
    # Dealing
    elif g.turn == 1:
        timer .2 repeat True action Function(g.first_deal)
    elif g.turn == 2: # Main game
        hbox:
            align 1.0,.5 xoffset -12 spacing 30
            button:
                align .5,.5
                xysize 308,108 background "cards/btn.png" hover_background "cards/btn1.png"
                text "I'm good." align .5,.5
                action Function(g.set_turn, 4)
            button:
                background None
                fixed:
                    fit_first True
                    add "cards/back.webp" at zoom(.4)
                    text "Draw one." align .5,.5
                action Function(g.draw)
    elif  g.turn == 3:
        pass

#############
    hbox: # Player cards
        align .5,1.0
        at zoom(.4)
        for i in g.player.hand:
            button:
                background None
                add i.img
                at card_game_ani
    hbox: # Enemy cards
        align .5,0.0
        at zoom(.4)
        for i in g.enemy.hand:
            button:
                background None
                if g.revealed:
                    add i.img
                else:
                    add "cards/back.webp"
                at card_game_ani
############# Total sum
    if len(g.player.hand):
        fixed:
            align .77,.5 fit_first True
            add "cards/points.png"

            if g.revealed: # Enemies hand
                text str(g.enemy.sum()):
                    size 50 align .5,.5 yoffset -130
                    if g.enemy.sum() > 21:
                        color "#f00"
                    elif g.enemy.sum() == 21:
                        color "#0f0"
                    else:
                        color "#fff"
            else:
                text "??" size 50 align .5,.5  yoffset -130
            text str(g.player.sum()): #player score
                size 50 align .5,.5  yoffset 130
                if g.player.sum()> 21:
                    color "#f00"
                elif g.player.sum() == 21:
                    color "#0f0"
                else:
                    color "#fff"
############# Auto wins
    if g.player.sum() == 21 or g.enemy.sum() > 21:
        timer .1 action Function(g.set_turn, 3), Show("blackjack_pay_time", winner = "player", amount = g.bet, game = g)
        button:
            action NullAction()
            background "#4f44"
        frame:
            align .5,.5 background "#000a" padding 20,20
            hbox:
                spacing 20
                text "You've gained {} soul points.".format(g.bet) align .5,.5
                button:
                    background "#000a" padding 20,20
                    text "Next"
                    action Function(g.next)
    if g.enemy.sum() == 21 or g.player.sum() > 21:
        timer .1 action Function(g.set_turn, 3), Show("blackjack_pay_time", winner = "enemy", amount = g.bet, game = g)
        button:
            action NullAction()
            background "#f444"
        frame:
            align .5,.5 background "#000a" padding 20,20
            hbox:
                spacing 20
                text "You've lost {} soul points.".format(g.bet) align .5,.5
                button:
                    background "#000a" padding 20,20
                    text "Next"
                    action Function(g.next)
############# AI's turn
    if g.turn == 4 and g.player.sum() < 21 and  g.enemy.sum() < 21:
        if g.player.sum() > g.enemy.sum():
            timer.2 repeat True action Function(g.draw, True)
        elif g.player.sum() == g.enemy.sum():
            button:
                action NullAction()
                background "#fff4"
            frame:
                align .5,.5 background "#000a" padding 20,20
                hbox:
                    spacing 20
                    text "Its a draw." align .5,.5
                    button:
                        background "#000a" padding 20,20
                        text "Next"
                        action Function(g.next)
        elif g.player.sum() < g.enemy.sum():
            timer .1 action Show("blackjack_pay_time", winner = "enemy", amount = g.bet, game = g)
            button:
                action NullAction()
                background "#f444"
            frame:
                align .5,.5 background "#000a" padding 20,20
                hbox:
                    spacing 20
                    text "You've lost {} soul points.".format(g.bet) align .5,.5
                    button:
                        background "#000a" padding 20,20
                        text "Next"
                        action Function(g.next)
############# complete lose
    if g.player.cash < 1:
        timer .1 action Return("player lost")
    elif g.enemy.cash < 1:
        timer .1 action Return("enemy lost")

screen blackjack_pay_time(winner, amount, game):
    timer .6 action Hide("blackjack_pay_time"), Function(game.pay, winner, amount)
    if winner == "enemy":
        hbox:
            align 0.0,0.0
            at blackjack_pay_animation(960, 540)
            add "cards/coins.png"
            text str(amount)
    elif winner == "player":
        hbox:
            align 1.0,1.0
            at blackjack_pay_animation(-960, -540)
            add "cards/coins.png"
            text str(amount)

transform blackjack_pay_animation(x, y):
    offset (x,y) zoom 2 alpha 0
    ease .6 offset (0,0) zoom 1 alpha 1


